<?php

/**
  * Payment module class, Gopay.php
  
  * @category modules
  *
  * @author Gopay <integrace@gopay.cz>
  * @version 1.2
  *
  */

$maxStateValue = Db::getInstance()->getValue('
SELECT max(`id_order_state`) FROM `'._DB_PREFIX_.'order_state`');
define('_PS_OS_GOPAY_', $maxStateValue);

require_once(_PS_MODULE_DIR_.'gopay/gopay_helper.php');
require_once(_PS_MODULE_DIR_.'gopay/gopay_soap.php');

class Gopay extends PaymentModule
{
	private	$_html = '';
	private $_postErrors = array();

	public function __construct()
	{
		$this->name = 'gopay';
		$this->tab = 'Payment';
		$this->version = '1.2';
		
		$this->currencies = true;
		$this->currencies_mode = 'radio';

        parent::__construct();

		$this->page = basename(__FILE__, '.php');
        $this->displayName = $this->l('GoPay');
        $this->description = $this->l('Platí GoPay');
		$this->confirmUninstall = $this->l('Opravdu chcete smazat platební modul GoPay?');
	}
	
	public function install()
	{
	
		$serverURL = 'http';
 		
		if ($_SERVER["HTTPS"] == "on") {$serverURL .= "s";}
 		$serverURL .= "://";
 		if ($_SERVER["SERVER_PORT"] != "80") {
  			$serverURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"];
 		}
 		else {
 			$serverURL .= $_SERVER["SERVER_NAME"];
 		}
 		
 		if (!parent::install()
			OR !Configuration::updateValue('GOID', '1234567890')
			OR !Configuration::updateValue('GOPAY_KEY', 'abcdefgh12345678abcdefgh')
			OR !Configuration::updateValue('GOPAY_SUCCESS_URL', $serverURL.__PS_BASE_URI__.'modules/gopay/validation.php')
			OR !Configuration::updateValue('GOPAY_FAILED_URL', $serverURL.__PS_BASE_URI__.'modules/gopay/infopage.php?errors=Platba byla zrušena')
			OR !Configuration::updateValue('GOPAY_BASE_URL', 'https://testgw.gopay.cz/zaplatit-plna-integrace')
			OR !Configuration::updateValue('GOPAY_WS_URL', 'https://testgw.gopay.cz/axis/EPaymentService?wsdl')
			OR !Configuration::updateValue('GOPAY_HISTORY_URL', $serverURL.__PS_BASE_URI__.'modules/gopay/infopage.php')
			OR !Configuration::updateValue('GOPAY_PRESENTATION', 'paymethods-all-hor.gif')
			
			OR !$this->registerHook('payment')
			OR !$this->registerHook('paymentReturn')
			OR !$this->registerHook('leftColumn'))
		return false;
	
		// vytvoreni noveho stavu awaiting GoPay
		Db::getInstance()->Execute(
        'INSERT INTO `'._DB_PREFIX_.'order_state` (`invoice`, `send_email`, `color`, `unremovable`, `hidden`, `logable`, `delivery`)
        VALUES ("1","1","#80b1ed","1","0","1","0");');

		$maxStateValue = Db::getInstance()->getValue('
		SELECT max(`id_order_state`) FROM `'._DB_PREFIX_.'order_state`');
		
		$langStateCount = Db::getInstance()->getValue('
		SELECT max(`id_lang`) FROM `'._DB_PREFIX_.'order_state_lang`');
		
		for ( $i=1; $i <= $langStateCount; $i++) {
			Db::getInstance()->Execute(
	        'INSERT INTO `'._DB_PREFIX_.'order_state_lang` (`id_order_state`, `id_lang`, `name`, `template`)
	        VALUES ('.$maxStateValue.','.$i.',"Čeká na platbu GoPay","gopay");');
		}
		
		// pridani noveho cms zaznamu - informace o GoPay
		Db::getInstance()->Execute(
        'INSERT INTO `'._DB_PREFIX_.'cms` (`id_cms`) VALUES("");');
			
		$maxCmsValue = Db::getInstance()->getValue('
		SELECT max(`id_cms`) FROM `'._DB_PREFIX_.'cms`');
		
		$langCmsCount = Db::getInstance()->getValue('
		SELECT max(`id_lang`) FROM `'._DB_PREFIX_.'cms_lang`');
				
		for ( $i=1; $i <= $langCmsCount; $i++) {
			Db::getInstance()->Execute(
        'INSERT INTO `'._DB_PREFIX_.'cms_lang` (`id_cms`, `id_lang`, `meta_title`, `meta_description`, `meta_keywords`, `content`, `link_rewrite`)
        VALUES ('.$maxCmsValue.', '.$i.',"GoPay","Mikroplatební systém GoPay","gopay, payment, secure payment, ssl",
        "<div align=\"right\"><a href=\"https://www.gopay.cz\" target=\"_blank\"><img src=\"https://www.gopay.cz/images/logo.gif\" alt=\"GoPay\" style=\"margin-right: 20px;\" /></a></div><h2>Preferujeme GoPay mikroplatby</h2><br />
        <p align=\"justify\">GoPay je platební systém pro rychlé, diskrétní a bezpečné platby na internetu. Moderní GoPay peněženka nabízí elektronickou variantu běžné peněženky pro drobné každodenní platby. Žádné vyplňování osobních údajů, žádné skryté poplatky, párkrát kliknete a můžete ihned diskrétně nakupovat. Rychle. Snadno. Zdarma. Kdykoliv.</p><br />
        <h5>Hlavní výhody GoPay peněženky:</h5>
        <ul><li>založení a užívání zdarma</li><li>žádné poplatky, žádné osobní údaje</li><li>registrace bez ověření</li><li>rychlé a snadné dobíjení (SMS, superCASH, GoKupon, Banka, Platební karta)</li><li>okamžité platby (na E-mail, SMS, GoKupon, Banka, GoPay)</li></ul><br />
        <h5>Jak snadno platit s GoPay</h5>
        <p><b>1. Založte si GoPay peněženku</b></p>
        <p>Během 30 sekund založíte GoPay peněženku na <a href=\"https://www.gopay.cz/nova-registrace\" target=\"_blank\">https://www.gopay.cz/nova-registrace</a></p>
        <p><b>2. Dobijte si peníze</b></p>
        <p>Finanční prostředky vložíte do GoPay peněženky dobíjením. Po přihlášení do GoPay peněženky zvolte odkaz <b>Dobíjení</b> a vyberte způsob převodu.</p>
        <p><b>3. Vyberte si zboží/službu</b></p>
        <p>S nabitou GoPay peněženkou si vyberte v E-shopu zboží/službu, o kterou máte zájem.</p>
        <p><b>4. Potvrďte objednávku</b></p>
        <p>Vyplňte údaje a potvrďte objednávku vybraného zboží/služby.</p>
        <p><b>5. Proveďte platbu</b></p>
        <p>Po potvrzení objednávky se otevře platební brána GoPay, po přihlášení do GoPay peněženky potvrdíte platbu tlačítkem Zaplatit.</p>
        <p><b>6. Vyřízení objednávky</b></p><br />
        <p>Platba je okamžitě automaticky provedena a objednávka vybraného zboží/služby ihned vyřízena.</p>
        <br /><a href=\"https://www.gopay.cz\" target=\"_blank\">https://www.gopay.cz</a>",
        "gopay");');
		}
						
	return true;
	}
		
	public function uninstall()
	{
		$orderStateId = Db::getInstance()->getValue('
		SELECT `id_order_state` FROM `'._DB_PREFIX_.'order_state_lang` WHERE `template` = "gopay"');
								
		Db::getInstance()->Execute('DELETE FROM `'._DB_PREFIX_.'order_state` WHERE `id_order_state` = '.$orderStateId.'');
		Db::getInstance()->Execute('DELETE FROM `'._DB_PREFIX_.'order_state_lang` WHERE `id_order_state` = '.$orderStateId.'');
		
		$cmsId = Db::getInstance()->getValue('
		SELECT `id_cms` FROM `'._DB_PREFIX_.'cms_lang` WHERE `link_rewrite` = "gopay"');
		
		Db::getInstance()->Execute('DELETE FROM `'._DB_PREFIX_.'cms` WHERE `id_cms` = '.$cmsId.'');
		Db::getInstance()->Execute('DELETE FROM `'._DB_PREFIX_.'cms_lang` WHERE `id_cms` = '.$cmsId.'');
		
		if (!Configuration::deleteByName('GOID')
			OR !Configuration::deleteByName('GOPAY_KEY')
			OR !Configuration::deleteByName('GOPAY_SUCCESS_URL')
			OR !Configuration::deleteByName('GOPAY_FAILED_URL')
			OR !Configuration::deleteByName('GOPAY_BASE_URL')
			OR !Configuration::deleteByName('GOPAY_WS_URL')
			OR !Configuration::deleteByName('GOPAY_HISTORY_URL')
			OR !Configuration::deleteByName('GOPAY_PRESENTATION')
									
			OR !parent::uninstall())
											
			return false;
		return true;
	}

	public function getContent()
	{
		if (isset($_POST['submitGopay']))
		{
			if (empty($_POST['goId']))
				$this->_postErrors[] = $this->l('EshopGoID je povinná položka.');
			elseif (!Validate::isInt($_POST['goId']))
				$this->_postErrors[] = $this->l('EshopGoID musí být číslo.');
			elseif (empty($_POST['gopayKey']))
				$this->_postErrors[] = $this->l('Secret je povinná položka.');
			elseif (empty($_POST['historyUrl']))
				$this->_postErrors[] = $this->l('Info URL je povinná položka.');
			elseif (!Validate::isUrl($_POST['historyUrl']))
				$this->_postErrors[] = $this->l('Špatný formát Info URL.');
			
				
			if (!sizeof($this->_postErrors))
			{
				Configuration::updateValue('GOID', strval($_POST['goId']));
				Configuration::updateValue('GOPAY_KEY', strval($_POST['gopayKey']));
				Configuration::updateValue('GOPAY_SUCCESS_URL', strval($_POST['successUrl']));
				Configuration::updateValue('GOPAY_FAILED_URL', strval($_POST['failedUrl']));
				Configuration::updateValue('GOPAY_BASE_URL', strval($_POST['baseUrl']));
				Configuration::updateValue('GOPAY_WS_URL', strval($_POST['wsUrl']));
				Configuration::updateValue('GOPAY_HISTORY_URL', strval($_POST['historyUrl']));
				Configuration::updateValue('GOPAY_PRESENTATION', strval($_POST['goPresentation']));
				$this->displayConf();
			}
			else
				$this->displayErrors();
		}

		$this->displayFormSettings();
		return $this->_html;
	}

	public function displayConf()
	{
		$this->_html .= '
		<div class="conf confirm">
			<img src="../img/admin/ok.gif" alt="'.$this->l('Confirmation').'" />
			'.$this->l('Konfigurace byla uložena').'
		</div>';
	}

	public function displayErrors()
	{
		$nbErrors = sizeof($this->_postErrors);
		$this->_html .= '
		<div class="alert error">
			<h3>'.($nbErrors > 1 ? $this->l('There are') : $this->l('There is')).' '.$nbErrors.' '.($nbErrors > 1 ? $this->l('errors') : $this->l('error')).'</h3>
			<ol>';
		foreach ($this->_postErrors AS $error)
			$this->_html .= '<li>'.$error.'</li>';
		$this->_html .= '
			</ol>
		</div>';
	}
			
	public function displayFormSettings()
	{
		$conf = Configuration::getMultiple(array('GOID', 'GOPAY_KEY','GOPAY_SUCCESS_URL','GOPAY_FAILED_URL','GOPAY_BASE_URL','GOPAY_WS_URL','GOPAY_HISTORY_URL','GOPAY_PRESENTATION'));
		$goId = array_key_exists('goId', $_POST) ? $_POST['goId'] : (array_key_exists('GOID', $conf) ? $conf['GOID'] : '');
		$gopayKey = array_key_exists('gopayKey', $_POST) ? $_POST['gopayKey'] : (array_key_exists('GOPAY_KEY', $conf) ? $conf['GOPAY_KEY'] : '');
		$successUrl = array_key_exists('successUrl', $_POST) ? $_POST['successUrl'] : (array_key_exists('GOPAY_SUCCESS_URL', $conf) ? $conf['GOPAY_SUCCESS_URL'] : '');
		$failedUrl = array_key_exists('failedUrl', $_POST) ? $_POST['failedUrl'] : (array_key_exists('GOPAY_FAILED_URL', $conf) ? $conf['GOPAY_FAILED_URL'] : '');
		$baseUrl = array_key_exists('baseUrl', $_POST) ? $_POST['baseUrl'] : (array_key_exists('GOPAY_BASE_URL', $conf) ? $conf['GOPAY_BASE_URL'] : '');
		$historyUrl = array_key_exists('historyUrl', $_POST) ? $_POST['historyUrl'] : (array_key_exists('GOPAY_HISTORY_URL', $conf) ? $conf['GOPAY_HISTORY_URL'] : '');
		$wsUrl = array_key_exists('wsUrl', $_POST) ? $_POST['wsUrl'] : (array_key_exists('GOPAY_WS_URL', $conf) ? $conf['GOPAY_WS_URL'] : '');
		$goPresentation = array_key_exists('goPresentation', $_POST) ? $_POST['goPresentation'] : (array_key_exists('GOPAY_PRESENTATION', $conf) ? $conf['GOPAY_PRESENTATION'] : '');

		if ($baseUrl=="https://testgw.gopay.cz/zaplatit-plna-integrace") 
		{
			$wsUrl="https://testgw.gopay.cz/axis/EPaymentService?wsdl";
			Configuration::updateValue('GOPAY_WS_URL', strval($wsUrl));
		}	
		else {
			$wsUrl="https://gate.gopay.cz/axis/EPaymentService?wsdl";
			Configuration::updateValue('GOPAY_WS_URL', strval($wsUrl));
		}
						
		$this->_html .= '
		<fieldset>
		<legend style="background-color: white;"><a href="https://www.gopay.cz/partnerstvi" target="_blank"><img src="../modules/gopay/logo_gopay_190x90.png" alt="Gopay" style="margin-top: 12px; margin-bottom: 12px;" /></a></legend>
			<br />	
			<p><b>GoPay</b> je platební systém pro online, diskrétní a bezpečné platby. Ikona GoPay zaručuje uživatelům pohodlí drobných plateb na internetu a obchodníkům jistotu okamžité platby za služby a zboží v elektronické komerci. Klíčovou výhodou je univerzální platební brána s nabídkou portfolia dalších platebních metod (superCASH, platební karty).</p>
		<p>Uživatel <b>GoPay peněženky</b> (kupující), který zvolí GoPay platbu na stránkách E-shopu, je přesměrován na platební bránu GoPay, kde je vyzván k provedení platby. Po zaplacení je zpět přesměrován na stránky E-shopu, kde obchodník expeduje zboží / službu.</p>
		<p><b>Obchodní účet</b> je zřízen každému obchodníkovi po úspěšně provedené integraci GoPay do E-shopu. Účet je bezlimitní a eviduje pouze přijaté finanční prostředky od uživatelů GoPay peněženky. Přijaté peníze lze převádět z obchodního účtu na předem definovaný bankovní účet obchodníka. Jedná se o tzv. vyúčtování, které zahrnuje minimální a jediné zpoplatnění z realizovaného obratu a převod finančních prostředků.</p>
		<p>Pokud obchodník provozuje více než jeden E-shop, lze založit více obchodních účtů s možností napárování na E-shopy v různých kombinacích.</p>
		<p><b>GoPay peněženka</b> je elektronická obdoba běžné peněženky pro rychlé každodenní platby, posílání nebo přijímání peněz po síti, bez poplatků, pohodlně a kdekoliv. S GoPay peněženkou může každý uživatel ihned, diskrétně a zcela zdarma platit za služby a zboží.</p>
		<p>Pro využití všech vlastností je nutné provést integraci E-shopu s platebním systémem GoPay. Tento krok je v tomto případě realizován instalací platebního modulu GoPay do Prestashopu.</p><br />
		<p><b>Výhody GoPay pro E-shop:</b></p>
		<ul><li>-   nejdynamičtější platební systém na českém internetu</li><li>-   komplexní rešení pro přijímaní plateb</li><li>-   1 integrace = 3 platební metody</li><li>-   vyšší rentabilita realizovaných obchodu</li><li>-   garance okamžité platby na obchodní účet</li><li>-   transparentní obchodní politika</li><li>-   žádné skryté náklady</li><li>-   unikátní slevový program pro zákazníky</li><li>-   příliv nových zákazníků</li></ul><br />
		<p>Zaujaly vás přednosti platebního systému GoPay? Máte otázky a zájem o obchodní partnerství? Více informací naleznete na <a href="https://www.gopay.cz" target="_blank" style="color: blue; text-decoration: underline;">https://www.gopay.cz</a> nebo nás prosím kontaktujte na e-mailové adrese <a href="mailto:podnikej@gopay.cz" target="_target" style="color: blue; text-decoration: underline;">podnikej@gopay.cz</a>. Máme pro vás připravený balíček obchodních výhod a silnou marketingovou podporu nejdynamičtějšího platebního systému na českém internetu.</p><br />
		<p>Vyplňte <a href="https://www.gopay.cz/partnerstvi" target="_blank" style="color: blue; text-decoration: underline;">formulář partnerství</a> na webu GoPay a získejte potřebné informace.</p>
		<br /><p><b>Kontaktní informace</b></p>
		<p>Technické informace, integrace <a href="mailto:integrace@gopay.cz" style="color: blue; text-decoration: underline;">integrace@gopay.cz</a></p>
		<p>Podpora, provozní otázky <a href="mailto:uzivej@gopay.cz" style="color: blue; text-decoration: underline;">uzivej@gopay.cz</a></p>
		<p>Smluvní podpora <a href="mailto:podnikej@gopay.cz" style="color: blue; text-decoration: underline;">podnikej@gopay.cz</a></p>
		<p><a href="https://www.gopay.cz" target="_blank" style="color: blue; text-decoration: underline;">https://www.gopay.cz</a></p>
		</fieldset>
		<br /><br />
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post" style="clear: both;">
		<fieldset>
			<legend><img src="../img/admin/contact.gif" />'.$this->l('Nastavení').'</legend><br /><br /><br />
			
			<label>'.$this->l('E-shop GoID').'</label>
			<div class="margin-form"><input type="text" size="80" name="goId" value="'.htmlentities($goId, ENT_COMPAT, 'UTF-8').'" /></div>
			<p class="hint clear" style="display: block; width: 600px; margin-left: 200px;">'.$this->l('"E-shop GoID" je identifikátor e-shopu (10ti místné číslo), který získáte okamžiku integrace GoPay (více na podnikej@gopay.cz).').'</p><br /><br /><br /><br /><br />
			
			<label>'.$this->l('Secret').'</label>
			<div class="margin-form">
			<input type="text" size="80" name="gopayKey" value="'.htmlentities($gopayKey, ENT_COMPAT, 'UTF-8').'" /></div>
			<p class="hint clear" style="display: block; width: 600px; margin-left: 200px;">'.$this->l('"Secret" je tajný kód (24 znaků) v rámci systému GoPay, který získáte v okamžiku integrace GoPay (více na podnikej@gopay.cz).').'</p><br /><br /><br /><br /><br />
									
			<label>'.$this->l('Platební brána URL').'</label>
			<div class="margin-form">
				<input type="radio" name="baseUrl" value="https://testgw.gopay.cz/zaplatit-plna-integrace" '.($baseUrl=='https://testgw.gopay.cz/zaplatit-plna-integrace' ? 'checked="checked"' : '').' /> '.$this->l('Test: https://testgw.gopay.cz').'
				<br />
				<input type="radio" name="baseUrl" value="https://gate.gopay.cz/zaplatit-plna-integrace" '.($baseUrl=='https://gate.gopay.cz/zaplatit-plna-integrace' ? 'checked="checked"' : '').' /> '.$this->l('Provoz: https://gate.gopay.cz').'
			</div>
			<p class="hint clear" style="display: block; width: 600px; margin-left: 200px;">'.$this->l('"Platební brána URL" představuje typ komunikace s platebním systémem GoPay.').'</p><br /></p><br /><br /><br /><br /><br />
	
			<label>'.$this->l('Prezentace platebních metod GoPay').'</label>
			<div class="margin-form">
				<table>
					<tr>
						<td>
							<input type="radio" name="goPresentation" value="paymethods-all-hor.gif" '.($goPresentation=='paymethods-all-hor.gif' ? 'checked="checked"' : '').' />
						</td>
						<td>
							'.$this->l('GoPay, superCASH, platební karty').'
						</td>
						<td>
							<img src="'.__PS_BASE_URI__.'modules/gopay/paymethods-all-hor.gif" alt="paymethods-all-hor.gif"/>
						</td>
						</div>
						<td>
							<img src="'.__PS_BASE_URI__.'modules/gopay/paymethods-all-ver.gif" alt="paymethods-all-ver.gif"/>
						</td>
					</tr>
				</table>
				<br />
				<table>
					<tr>
						<td>
							<input type="radio" name="goPresentation" value="paymethods-cards-hor.gif" '.($goPresentation=='paymethods-cards-hor.gif' ? 'checked="checked"' : '').' />
						</td>
						<td>
							'.$this->l('GoPay, platební karty&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;').'	
						</td>
						<td>
							<img src="'.__PS_BASE_URI__.'modules/gopay/paymethods-cards-hor.gif" alt="paymethods-all-hor.gif"/>
						</td>
						<td>
							<img src="'.__PS_BASE_URI__.'modules/gopay/paymethods-cards-ver.gif" alt="paymethods-cards-ver.gif"/>
						</td>
					</tr>
				</table>
				<br />
				<table>
					<tr>
						<td>
							<input type="radio" name="goPresentation" value="paymethods-supercash-hor.gif" '.($goPresentation=='paymethods-supercash-hor.gif' ? 'checked="checked"' : '').' />
						</td>
						<td>
							'.$this->l('GoPay, superCASH&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;').'
						</td>
						<td>	
							<img src="'.__PS_BASE_URI__.'modules/gopay/paymethods-supercash-hor.gif" alt="paymethods-supercash-hor.gif"/>
						</td>
						<td>	
							<img src="'.__PS_BASE_URI__.'modules/gopay/paymethods-supercash-ver.gif" alt="paymethods-supercash-ver.gif"/>
						</td>
					</tr>
				</table>
				<table>
					<tr>
						<td>
							<input type="radio" name="goPresentation" value="paymethods-gopay.gif" '.($goPresentation=='paymethods-gopay.gif' ? 'checked="checked"' : '').' />
						</td>
						<td>
							'.$this->l('GoPay&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;').'
						</td>
						<td>	
							<img src="'.__PS_BASE_URI__.'modules/gopay/paymethods-gopay.gif" alt="paymethods-gopay.gif"/>
						</td>
					</tr>
				</table>
			</div>
			<p class="hint clear" style="display: block; width: 600px; margin-left: 200px;">'.$this->l('Pomocí "Prezentace platebních metod GoPay" vyberete platební metody, které máte uvedené ve smlouvě s GoPay.').'</p><br /></p><br /><br /><br /><br /><br />
			
			<input type="hidden" name="successUrl" value="'.htmlentities($successUrl, ENT_COMPAT, 'UTF-8').'" />
			<input type="hidden" name="failedUrl" value="'.htmlentities($failedUrl, ENT_COMPAT, 'UTF-8').'" />
			<input type="hidden" name="wsUrl" value="'.htmlentities($wsUrl, ENT_COMPAT, 'UTF-8').'" />
			<input type="hidden" name="historyUrl" value="'.htmlentities($historyUrl, ENT_COMPAT, 'UTF-8').'" />
					
			<center><input type="submit" name="submitGopay" value="'.$this->l('Uložit').'" class="button" /></center></div>
		</fieldset>
		</form><br /><br />
		';
	}
		
	public function hookPayment($params)
	{
		global $smarty;
			
		$goPresentation = trim(Configuration::get('GOPAY_PRESENTATION'));
		$payUrl = 'modules/gopay/pay.php';
								
		$smarty->assign(array(
			'payUrl' => $payUrl,
			'goPresentation' => $goPresentation,
			'cartId' => intval($params['cart']->id)
		));
												
		return $this->display(__FILE__, 'gopay.tpl');
	}
	
	public function getL($key)
	{
		$translations = array(
			'faultyPaymentIdentity' => $this->l('Nepodařilo se ověřit identitu platby.<br />Kontaktujte e-shop.'),
			'paymentCreationFailed' => $this->l('Nepodařilo se vytvořit platbu GoPay.<br />Zkontrolujte konfiguraci platebního modulu GoPay.'),
			'czk' => $this->l('E-shop nemá nastavenou českou měnu s platným ISO kódem CZK.<br />'),
			'paymentNotVerified' => $this->l('Platba nebyla ověřena.<br />'),
			'undefinedOrderFaultyState' => $this->l('Objednávka nebyla nalezena nebo je v chybném stavu.'),
			'alreadyPaid' => $this->l('Objednávka již byla uzavřena. Vyberte zboží znovu.'),
			'waitingSupercashPayment' => $this->l('Platba metodou superCASH čeká na zaplacení.<br />')
		);
		return $translations[$key];
	}
	
	function hookLeftColumn($params)
	{
		$cmsId = Db::getInstance()->getValue('
		SELECT `id_cms` FROM `'._DB_PREFIX_.'cms_lang` WHERE `link_rewrite` = "gopay"');
		
		$goPresentation = trim(Configuration::get('GOPAY_PRESENTATION'));
		
		if ($goPresentation=='paymethods-all-hor.gif') {
			$goPresentation='paymethods-all-ver.gif';
		}
		elseif ($goPresentation=='paymethods-cards-hor.gif') {
			$goPresentation='paymethods-cards-ver.gif';
		}
		elseif ($goPresentation=='paymethods-supercash-hor.gif') {
			$goPresentation='paymethods-supercash-ver.gif';
		}
		else {
			$goPresentation='paymethods-gopay.gif';
		}
		
		global $smarty;
		$smarty->assign('securepayment', $this->l('secure-payment'));
		$smarty->assign('cmsId', $cmsId);
		$smarty->assign('goPresentation', $goPresentation);
		return $this->display(__FILE__, 'blockpaymentlogogopay.tpl');
	}
	
	function hookRightColumn($params)
	{
		return $this->hookLeftColumn($params);
	}

	function hookFooter($params)
	{
		return $this->hookLeftColumn($params);
	}
			
}
